//Yo, credit goes to CobaltBW for their amazing Drop Dash script. A lof ot this stuff is theirs, so go give 'em a pat on the back for this awesome ability. :V

freeslot(
"sfx_drpdsh",
"S_DROPDASH1",
"S_DROPDASH2",
"S_DROPDASH3",
"S_DROPDASH4",
"S_DDCHARGE"
)
sfxinfo[sfx_drpdsh] = {
	singular = false,
	caption = "Drop Dash"
}

//DROPDASH CHARGE STATE
states[S_DDCHARGE] = {SPR_PLAY,SPR2_BNCE|FF_ANIMATE,7,nil,1,1,S_PLAY_ROLL}

//DROPDASH STATES
states[S_DROPDASH1] = {
	sprite = SPR_CDAS,
	frame = A,
	tics = 1,
	nextstate = S_DROPDASH2
}

states[S_DROPDASH2] = {
	sprite = SPR_CDAS,
	frame = B,
	tics = 1,
	nextstate = S_DROPDASH3
}

states[S_DROPDASH3] = {
	sprite = SPR_CDAS,
	frame = C,
	tics = 1,
	nextstate = S_DROPDASH4
}

states[S_DROPDASH4] = {
	sprite = SPR_CDAS,
	frame = D,
	tics = 1,
	nextstate = S_DROPDASH1
}

//DROPDASH STUFF

addHook("ThinkFrame", function()//addHook("PreThinkFrame", function()
	for player in players.iterate()
		local mo = player.mo
		if player.mo.skin == "msonic"
			
			//Initialize
			if player.dropswap == nil then
				player.dropswap = 0
			end
			
			local cs_dm_threshold = (3*TICRATE)
			local jump = player.cmd.buttons&BT_JUMP
			local spin = player.cmd.buttons&BT_USE
			local jumplast = player.pflags&PF_JUMPDOWN
			local spinlast = player.pflags&PF_USEDOWN
			local lastswap = player.dropswap		
			local shieldtype = player.powers[pw_shield]&~(SH_PITY|SH_PINK|SH_STACK) and not(player.powers[pw_super])
			
			if P_IsObjectOnGround(mo) then
				player.dropswap = 0
			end
			if player.pflags&PF_JUMPED
				//Holding jump key
				if (jumplast) and not(spin)
					player.dropswap = 0
				end
				//Use shield ability on jump if secondary jump is exhausted
				if (jump and not jumplast and (player.cmd.buttons&BT_USE and shieldtype))//(jump and not jumplast and player.secondjump and shieldtype)
					player.dropswap = 1
					player.pflags = $&~PF_USEDOWN
					player.cmd.buttons = $|BT_USE
				end
			end
		end
	end
end)

addHook("ShieldSpecial", function(player)
	local mo = player.mo
	if player.mo.skin == "msonic"
		if not(player.dropswap) then return true end
		player.secondjump = 0
	end
end)

addHook("SpinSpecial", function(player)
	local mo = player.mo
	//Drop dash
	local shieldtype = player.powers[pw_shield]&~(SH_PITY|SH_PINK|SH_STACK)
	if player.mo.skin == "msonic"
		if player.pflags&PF_JUMPED and not(player.pflags&PF_USEDOWN)
		and not(shieldtype and player.dropswap)
			mo.dropprep = 1
			mo.dropmomz = 0
		return true end
		if (player.cmd.buttons&BT_USE and player.jump) and shieldtype//player.secondjump
			player.pflags = $&~PF_THOKKED
		end
	end
end)

local StopDropDash = function(player)
	local mo = player.mo
	if not(mo.dropprep) then return end
	mo.dropprep = 0
	if player.pflags&(PF_SPINNING) or (player.pflags&PF_JUMPED and not(player.pflags&PF_NOJUMPDAMAGE))
		mo.state = S_PLAY_ROLL
	end
end


addHook("AbilitySpecial",function(player)
	if player.mo.skin == "msonic"
		player.mo.dropprep = min(1,$)
	end
end)

addHook("ThinkFrame",function(player)
	for player in players.iterate()
		if player.mo.skin == "msonic"
			if player.mo.dropprep == nil then
				player.mo.dropprep = 0
				player.mo.dropmomz = 0
			end
			if P_PlayerInPain(player) or not(player.playerstate == PST_LIVE) or player.exiting or player.powers[pw_nocontrol]
				StopDropDash(player)
			end
			local mo = player.mo

			//Cancel dropdash
			if (not(player.cmd.buttons & BT_USE) and mo.dropprep)
			or mo.eflags & MFE_SPRUNG
			or P_PlayerInPain(player)
			or (not (mo.eflags & MFE_JUSTHITFLOOR) and not((player.pflags&PF_JUMPED)&~PF_NOJUMPDAMAGE))
			//or player.powers[pw_shield]
				StopDropDash(player)
			continue end
			
			//Handle dropdash
			if player.charability == CA_THOK and player.charability2 == CA2_SPINDASH 
				if mo.dropprep
					and not(mo.state >= S_PLAY_SUPER_TRANS1 and mo.state <= S_PLAY_SUPER_TRANS1+5)
					//Air state
					if not (mo.eflags & MFE_JUSTHITFLOOR)
						//Charge dropdash
						if (player.cmd.buttons & BT_USE or (player.cmd.buttons & BT_USE and player.cmd.buttons & BT_JUMP))
							if mo.dropprep < 100
								if not (mo.state == S_DDCHARGE) and not (mo.dropprep > 70)
									mo.state = S_DDCHARGE
									player.pflags = $1 & ~PF_SPINNING
								end
								mo.dropprep = $+100/10
								//if mo.momz >= 0
								//lines
								for i = 1, 2 do //8
									local fxdcharge1 = P_SpawnMobj(mo.x+FixedMul((P_RandomRange(-24, 24)*FRACUNIT), cos(mo.angle+ANGLE_90)), mo.y+FixedMul((P_RandomRange(-24, 24)*FRACUNIT), sin(mo.angle+ANGLE_90)), mo.z-(P_RandomRange(4, 12)*P_MobjFlip(mo))*FRACUNIT, MT_DCHS)
									fxdcharge1.color = mo.color
									fxdcharge1.scale = $/2
									fxdcharge1.destscale = $/P_RandomRange(1,2)
									fxdcharge1.scalespeed = mo.scale/P_RandomRange(4,8)
									fxdcharge1.eflags = mo.eflags & MFE_VERTICALFLIP
									fxdcharge1.momx, fxdcharge1.momy = mo.momx, mo.momy
									P_SetObjectMomZ(fxdcharge1, 160)
								end
								if(leveltime%2 == 0)
									//1
									local fxcstrikeAI1 = P_SpawnGhostMobj(player.mo)
									fxcstrikeAI1.tics = 2
									fxcstrikeAI1.color = mo.color
									fxcstrikeAI1.eflags = mo.eflags & MFE_VERTICALFLIP
								//end
								end
								//stronger particles
								if(leveltime%6 == 0)
									local fxdcharge2 = P_SpawnMobj(mo.x+FixedMul((P_RandomRange(-14, 14)*FRACUNIT), cos(mo.angle+ANGLE_90)), mo.y+FixedMul((P_RandomRange(-14, 14)*FRACUNIT), sin(mo.angle+ANGLE_90)), mo.z+(P_RandomRange(-24, 0)*P_MobjFlip(mo))*FRACUNIT, MT_DCHR)
									fxdcharge2.color = mo.color
									fxdcharge2.destscale = $/P_RandomRange(1,2)
									fxdcharge2.scalespeed = mo.scale/4
									fxdcharge2.eflags = mo.eflags & MFE_VERTICALFLIP
									fxdcharge2.momx, fxdcharge2.momy = mo.momx, mo.momy
									P_SetObjectMomZ(fxdcharge2, 80)
								end
								if mo.dropprep >= 100
									S_StartSound(mo, sfx_drpdsh, player)
									mo.dropprep = 100
									mo.state = S_DROPDASH1
									// spinny particle thing that doesnt work because i am bad
									//local fxddSpin = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DDSP)
									//fxddSpin.angle = player.drawangle
									//fxddSpin.color = mo.color
									//fxddSpin.eflags = mo.eflags & MFE_VERTICALFLIP
									//if player.cmd.buttons & BT_USE
									//	fxddSpin.rollangle = $+5
									//	fxddSpin.x = mo.x
									//	fxddSpin.y = mo.y
									//	fxddSpin.z = mo.z
									//end
									//mo.player.dashmode = $+1
								end
							end
							//Fully charged
							if mo.dropprep == 100
								if(leveltime%2 == 0)
									//1
									local fxcstrikechargedA1 = P_SpawnGhostMobj(player.mo)
									fxcstrikechargedA1.tics = 2
									fxcstrikechargedA1.color = mo.color
									fxcstrikechargedA1.eflags = mo.eflags & MFE_VERTICALFLIP
								//end
								end
								mo.dropmomz = mo.momz
							end
						end
					//Grounded state
					else
						//Execute dropdash
						if player.cmd.buttons & BT_USE and mo.dropprep == 100
							mo.state = S_PLAY_ROLL
							player.pflags = $1|PF_SPINNING
							S_StartSound(mo, sfx_zoom, player)
							local speed = abs(player.mo.dropmomz/2)+FixedHypot(player.rmomx,player.rmomy)
							local actionspd = player.actionspd
							if player.powers[pw_super] then
								actionspd = $*3/2
							end
							if mo.eflags&MFE_UNDERWATER then actionspd = $*2/3 end
							P_InstaThrust(mo, mo.angle,max(actionspd,speed))
							
							//Dust
							local function r(mo,value)
								local w = mo.radius/FRACUNIT/2
								return value+P_RandomRange(-w,w)*FRACUNIT
							end
							for n = 1,4
								local d = P_SpawnMobj(r(mo,mo.x),r(mo,mo.y),mo.z,MT_SPINDUST)
								d.extravalue1 = FRACUNIT
								d.extravalue2 = FRACUNIT
								if P_MobjFlip(mo) == -1 then
									d.eflags = $|MFE_VERTICALFLIP
								end
								P_SetObjectMomZ(d,FRACUNIT*2)
								local l = 90*n/4
								P_InstaThrust(d,mo.angle+ANGLE_135+l*ANG1,actionspd/2)
							end
						end
						//Reset
						StopDropDash(player)
					end
				end
			end
		end
	end
end)