// hehehe neo sonic go squish brrrr
// sal helped

addHook("PlayerThink", function(player)
	// Store the object in another variable for easy access :)
	local mo = player.mo;
	if not (mo and mo.valid)
		// The player object doesn't exist, so not much we can do!
		return
	end

	// Ease your scale back to normal if it's changed.
	if (mo.himsquish)
		local squishSpeed = FRACUNIT / 8
		if (mo.squishtimer > 55)
			// This holds it on on the large squish for a bit before going back.
			squishSpeed = FRACUNIT / 128
		end

		local xdiff = mo.spritexscale - FRACUNIT
		local ydiff = mo.spriteyscale - FRACUNIT

		if (abs(xdiff) <= squishSpeed)
			mo.spritexscale = FRACUNIT
		else
			if (xdiff > 0)
				mo.spritexscale = $1 - squishSpeed
			else
				mo.spritexscale = $1 + squishSpeed
			end
		end

		if (abs(ydiff) <= squishSpeed)
			mo.spriteyscale = FRACUNIT
		else
			if (ydiff > 0)
				mo.spriteyscale = $1 - squishSpeed
			else
				mo.spriteyscale = $1 + squishSpeed
			end
		end

		if (mo.squishtimer > 0)
			// Reduce squish timer.
			mo.squishtimer = $1 - 1
		end

		if (mo.squishtimer <= 0)
			// Reset squish variables now that we're done.
			mo.spritexscale = FRACUNIT
			mo.spriteyscale = FRACUNIT
			mo.himsquish = 0
		end
	end

	// If you're Neo Sonic, do the floor squishing!
	if (mo.skin == "msonic")
		// These variables don't exist, so we need to initialize them.
		if (mo.wasonground == nil)
			mo.wasonground = P_IsObjectOnGround(mo)
		end

		if (mo.airmomz == nil)
			mo.airmomz = mo.momz
		end

		// If you're on the ground, but were not during the previous tic, then squish.
		if (P_IsObjectOnGround(mo) and not mo.wasonground)
			// The momz value you need to be at to be 1:1 with baseSquishStrength.
			// You can change this to modify how quickly it reaches the extreme value.
			local baseMomz = 20*FRACUNIT

			// The base squish amount.
			// Make this value larger for extreme squishing, or smaller for subtle squishing.
			local squishValue = 2*FRACUNIT

			// Minimum and maximum values. Likely won't need changed.
			local maxSquish = 4*FRACUNIT
			local minSquish = FRACUNIT/4

			// Our momenum when landing.
			// Absolute value, since we don't want this to be negative.
			local ourMomz = abs(mo.airmomz)

			// Final squish strength.
			// ourMomz relative to baseMomz.
			local squishStrength = FixedDiv(ourMomz, baseMomz)

			local invert = FixedDiv(FRACUNIT, squishValue);
			mo.spritexscale = FRACUNIT + FixedMul(squishStrength, squishValue - FRACUNIT)
			mo.spriteyscale = FRACUNIT - FixedMul(squishStrength, invert)

			if (mo.spritexscale > maxSquish)
				mo.spritexscale = maxSquish
			end

			if (mo.spriteyscale < minSquish)
				mo.spriteyscale = minSquish
			end

			mo.himsquish = 1
			mo.squishtimer = 60
		end

		// Set the new previous tic values.
		mo.wasonground = P_IsObjectOnGround(mo)
		mo.airmomz = mo.momz
	end
end)

